日星网 windows 中文论坛

 找回密码
 加入我们

QQ登录

只需一步,快速开始

查看: 83|回复: 0

【解决方法】CentOS 7 升级python2到python3后 yum指令失效

[复制链接]
发表于 2020-4-14 03:06:10 | 显示全部楼层 |阅读模式
升级python2到python3之后,使用yum命令时报一下错误:

  1. [root@localhost ~]# yum -y install zlib
  2.   File "/usr/bin/yum", line 30
  3.     except KeyboardInterrupt, e:
  4.                             ^
  5. SyntaxError: invalid syntax
复制代码


这是因为yum采用python作为命令解释器,这可以从/usr/bin/yum文件中第一行#!/usr/bin/python发现。而python版本之间兼容性不太好,使得2.X版本与3.0版本之间存在语法不一致问题。当系统将python升级到2.7或3.6后,出现语法解释错误。

解决办法:

一是修改yum的解释器为旧版本python2.7(如果你没有采用覆盖升级的话)。

修改yum的解释器为旧版本python2.7:

  1. $ vi /usr/bin/yum
复制代码


将第一行"#!/usr/bin/python" 改为 "#!/usr/bin/python2.7"即可。

所以将/usr/bin/yum中的开头修改为:#!/usr/bin/python2.7即可。
之后还是会遇到错误如下图




这又是python版本的问题,所以又将/usr/libexec/urlgrabber-ext-down的第一行#!/usr/bin/python修改为了#!/usr/bin/python2.7,就可以正常安装了。


您需要登录后才可以回帖 登录 | 加入我们

本版积分规则

手机版|小黑屋|日星网

GMT, 2020-6-1 01:04 AM , Processed in 0.016900 second(s), 18 queries .

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表